#ifndef _D2_CONFIG__
#define _D2_CONFIG__

#include "d2stats.h"
/* This file includes some tunable defaults. */

/* PREFIX is the default path where d2stats is installed. */
#ifdef WIN32
#define PREFIX "."
#else
#define PREFIX "/usr/local"
#endif

/* You will need to change this location to match where your configuration
   file is located. */
#ifdef WIN32
#define config_file "d2stats.conf"
#else
#define config_file PREFIX DIR_SLASH "etc/d2stats.conf"
#endif

/* Default location for data files. This can be overriden (and usually is)
   by the parameters in d2stats.conf. */
#ifdef WIN32
#define data_prefix "."
#else
#define data_prefix PREFIX DIR_SLASH "share/d2stats"
#endif

/* Default location of the PvPGN directory. */
#ifdef WIN32
#define pvpgn_prefix "."
#else
#define pvpgn_prefix "/srv/pvpgn"
#endif

/* Hardcoded config defaults. */
char *config_defaults[] = {
  "MagicPrefix.txt", /* magic prefix name file */
  "MagicSuffix.txt", /* magic suffix name file */
  "RarePrefix.txt", /* rare name1 file */
  "RareSuffix.txt", /* rare name2 file */
  "armor.txt", /* armor item table file */
  "weapons.txt", /* weapons item table file */
  "misc.txt",  /* miscellaneous item table file */
  "UniqueItems.txt", /* unique item table file */
  "SetItems.txt", /* set item table file */
  "Runes.txt", /* runeword name file */
  "ItemStatCost.txt", /* property table file */
  "skilldesc.txt", /* skill name file */
  "string.tbl", /* standard string table */
  "expansionstring.tbl", /* expansion string table */
  "patchstring.tbl", /* patch string table */
  "character", /* default mode ('character' or 'stats') */
  "no", /* hardcore filtering (only process hardcore chars) */
  "no", /* ladder filtering (only process ladder chars) */
  "0", /* season number - for display purposes */
  "Undefined", /* server name - for display purposes */
  "", /* URL to character XSLT stylesheet */
  "", /* URL to list XSLT stylesheet */
  pvpgn_prefix DIR_SLASH "charsave", /* charsave path */
  pvpgn_prefix DIR_SLASH "charinfo", /* charinfo path */
  pvpgn_prefix DIR_SLASH "users", /* flat acct file path */
  "no", /* whether or not to attempt to read account files */
  pvpgn_prefix DIR_SLASH "reports", /* game report file path */
  "no", /* whether or not to attempt to read reports */
  pvpgn_prefix DIR_SLASH "reports" DIR_SLASH "backups", /* report backups */
  pvpgn_prefix DIR_SLASH "reports" DIR_SLASH "d2.log", /* report log */
  "yes", /* whether not to attempt to log and backup reports */
  data_prefix, /* where to look for tables */
  "", /* CGI interface to d2stats in character mode, if any */
  "%.xml", /* default character output file */
  "season%.xml" /* default list output file */
};

#endif
