#!/usr/local/bin/perl

# Simple wrapper script to use d2stats.

# adapted from http://kac.poliod.hu/~mystro/info/perlweb/ch03.htm
sub parse_input {
    my $buf, @pairs;
    if($ENV{'REQUEST_METHOD'} eq 'POST') {
	read(STDIN, $buf, $ENV{'CONTENT_LENGTH'}); }
    else {
	$buf = $ENV{'QUERY_STRING'}; }
    @pairs = split(/&/, $buf);
    for my $pair (@pairs) {
	my ($key, $val) = split(/=/, $pair, 2);
	$val =~ tr/+/ /;
	$val =~ s/%(..)/pack("c", hex($1))/ge;
	$data{$key} = $val; }
    return 0; }

sub trim($) {
    my $str = shift;
    $str =~ s/^\s+//;
    $str =~ s/\s+$//;
    return $str; }

sub err($) {
    my $str = shift;
    print("Content-type: text/html\n\n");
    print "$script_name: $str<br/>\n";
    exit(1); }

# Comment the following line to try running this from the command-line
# for debugging purposes.
&parse_input();

$script_name = $ENV{SCRIPT_FILENAME};
$script_name =~ s/^.*\///;
$client_ip = $ENV{REMOTE_ADDR};

$character = lc(&trim($data{'character'}));

# Change these lines if necessary according to account_allowed_symbols
# in bnetd.conf, and in d2cs.conf
$character =~ s/[^A-Za-z0-9-_\[\]\(\)]//g;

# Change these paths as necessary.
$pvpgn_path = "/srv/pvpgn";
$char_path = "$pvpgn_path/charsave";
$char_filename = "$char_path/$character";

# Change these executable locations as necessary.
$d2stats = "/usr/local/bin/d2stats";
$d2stats_args = "-c $char_filename";

&err("no character specified\n") if(!defined($data{'character'}) || $character eq "");

&err("perl is not running with the necessary permissions\n")
    unless(-x $char_path);
&err("character \"$character\" does not exist\n")
    unless(-e $char_filename);
$slurp = $\;
undef $\;
open(d2stats_pipe, "$d2stats $d2stats_args |")
    or &err("cannot execute $d2stats\n");
@print_output = <d2stats_pipe>;
print("Content-type: text/xml\n\n");
for my $line (@print_output) {
    print("$line"); }
close(d2stats_pipe);
