#ifndef _D2PRINT_H__
#define _D2PRINT_H__

#include "d2stats.h"

/* print_char.c */
/* Couple enum-to-cstr conversion functions. Used to contain a lot more. */
char *char_class_to_cstr(const enum char_class_t char_class);
char *abbr_class_to_cstr(const enum char_class_t char_class);
char *char_title_to_cstr(const enum char_title_t char_title, const enum char_class_t char_class, const enum flag_t is_hardcore);
void print_info(const struct charinfo_t *charinfo);

/* print_items.c */ 
/* Debug item output, and some enum-to-cstr functions. */
char *item_location_to_cstr(const enum item_location_t location);
char *item_worn_to_cstr(const enum item_worn_t worn);
char *item_section_to_cstr(const enum item_section_t section);
char *item_grid_loc_to_cstr(const enum item_grid_loc_t grid);
char *item_qual_to_cstr(const enum quality_t qual);
void print_affix_set(const uint16 *affix, const unsigned int pos);
void print_extended_item(struct item_t *item, const unsigned int clvl, const uint8 *set_info);
void print_item_name(struct item_t *item);
void print_item_loc(struct item_t *item);
unsigned int print_item_flags(struct item_t *item);
void print_item(struct item_t *item, const unsigned int clvl, const uint8 *set_info);
void print_set_bonuses(const struct charinfo_t *charinfo);

/* print_prop.c */
/* A very large function that prints a prop_t structure, or a proplist. */
unsigned int print_prop(FILE *file, struct prop_t **prop_out, const unsigned int clvl);
void sort_prop(struct prop_t **list, const unsigned int count);
unsigned int print_prop_list(struct prop_t *prop, const unsigned int clvl, const char *sep);

/* print_list.c */
/* Debug list output. */
void print_list_name(const struct charinfo_t *entry);
void print_list_exp(struct charinfo_t **list, const unsigned int entry_count);
void print_list_ival(struct charinfo_t **list, const unsigned int entry_count);
void print_list_rune(struct charinfo_t **list, const unsigned int entry_count);
void print_list_gold(struct charinfo_t **list, const unsigned int entry_count);
void print_list_mf(struct charinfo_t **list, const unsigned int entry_count);
void print_list_skill(struct charinfo_t **list, const unsigned int entry_count);
void print_list_fcr(struct charinfo_t **list, const unsigned int entry_count);
void print_list_ias(struct charinfo_t **list, const unsigned int entry_count);
void print_list_melee(struct charinfo_t **list, const unsigned int entry_count);
void print_list_alive(struct charinfo_t **list, const unsigned int entry_count);
void print_list(struct list_t *list);

#endif
