#include <stdio.h>

#include "d2stats.h"
#include "tbl.h"
#include "print.h"

/* This whole file is kinda useless. It's just debug functions that 
   have been abandoned for XML. The file isn't commented. */

/* Prints someone's name, title, ladder / hardcore status, etc. */
void print_list_name(const struct charinfo_t *entry) {
  char *title, name[50], *name_ptr = name;
  if(entry->is_hardcore == yes) {
    sprintf(name_ptr, "(H) ");
    name_ptr += 4; }
  if(entry->is_ladder == yes) {
    sprintf(name_ptr, "(L) ");
    name_ptr += 4; }
  if((title = char_title_to_cstr(entry->char_title, entry->char_class, entry->is_hardcore)) && title[0] != '\0') {
    sprintf(name_ptr, "%s %s", title, entry->name); }
  else {
    sprintf(name_ptr, "%s", entry->name); }
  printf("%-32s", name);
}

void print_list_exp(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by experience:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%12d\n", (list[pos]->stats).exp);
    }
  }
}

void print_list_ival(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by estimated total item value:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%12.2f\n", (list[pos]->bonus_stats).ival);
    }
  }
}

void print_list_rune(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  char runetag[5], *rune;
  printf("Characters sorted by highest carried rune:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      runetag[0] = 'r';
      runetag[1] = (list[pos]->bonus_stats).high_rune / 10 + '0';
      runetag[2] = (list[pos]->bonus_stats).high_rune % 10 + '0';
      runetag[3] = 'L';
      runetag[4] = '\0';
      if((rune = lookup_string_by_name(runetag))) {
	printf("%s", rune); }
      else {
	printf("%2d", (list[pos]->bonus_stats).high_rune); }
      if((list[pos]->bonus_stats).high_rune_count > 1) {
	printf(" x%d", (list[pos]->bonus_stats).high_rune_count); }
      printf("\n");
    }
  }
}

void print_list_gold(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total gold:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%12d\n", (list[pos]->stats).gold + (list[pos]->stats).gold_stash);
    }
  }
}

void print_list_mf(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total equipped magic find:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%5d%%\n", (list[pos]->bonus_stats).mf);
    }
  }
}

void print_list_skill(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total equipped +skill:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%d/%d/%d/%d\n", (list[pos]->bonus_stats).skill0, (list[pos]->bonus_stats).skill1, (list[pos]->bonus_stats).skill2, (list[pos]->bonus_stats).skill3);
    }
  }
}

void print_list_fcr(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total equipped faster casting rate:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%5d%%\n", (list[pos]->bonus_stats).fcr);
    }
  }
}

void print_list_ias(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total equipped increased attack speed:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%5d%%\n", (list[pos]->bonus_stats).ias);
    }
  }
}

void print_list_melee(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters sorted by total equipped melee bonuses:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%3d%%/%3d%%/%3d%%\n", (list[pos]->bonus_stats).ds, (list[pos]->bonus_stats).cb, (list[pos]->bonus_stats).ow);
    }
  }
}

void print_list_alive(struct charinfo_t **list, const unsigned int entry_count) {
  unsigned int pos;
  printf("Characters (still alive) sorted by experience:\n");
  for(pos = 0; pos < entry_count; pos++) {
    if(list[pos]) {
      printf("%2d. ", pos + 1);
      print_list_name(list[pos]);
      printf("\tLevel %2d %s\t", (list[pos]->stats).level, abbr_class_to_cstr(list[pos]->char_class));
      printf("%12d\n", (list[pos]->stats).exp);
    }
  }
}

void print_list(struct list_t *list) {
  enum char_class_t pos;
  printf("%d total characters.\n", list->char_count);
  for(pos = ama; pos <= src; pos++) {
    printf("%s: %d (%2.2f%%)\n", abbr_class_to_cstr(pos), list->class_count[pos], list->class_count[pos] * 100.0 / list->char_count);
  }
  printf("Stone of Jordan count: %d\n", list->soj_count);
  printf("Annhilius count: %d\n", list->annhi_count);
  printf("Hellfire Torch count: %d\n", list->torch_count);
  printf("Standard of Heroes count: %d\n\n", list->std_count);
  printf("Lists:\n\n");
  print_list_exp(list->by_exp, 50);
  print_list_ival(list->by_ival, 20);
  print_list_rune(list->by_rune, 20);
  print_list_gold(list->by_gold, 20);
  print_list_mf(list->by_mf, 20);
  print_list_skill(list->by_skill, 10);
  print_list_fcr(list->by_fcr, 10);
  print_list_ias(list->by_ias, 10);
  print_list_melee(list->by_melee, 10);
  print_list_alive(list->by_alive, 10);
}
