#ifndef _D2_XML__
#define _D2_XML__

/* xml.c */
/* *VERY* basic XML functions, along with a few functions that print headers
   and character info. */
void xml_open_tag(FILE *file, const char *tag);
void xml_open_attr(FILE *file, const char *tag, const char *attr, const char *val);
void xml_close_tag(FILE *file, const char *tag);
void xml_open_tree(FILE *file, const char *tag);
void xml_open_tree_attr(FILE *file, const char *tag, const char *attr, const char *val);
void xml_open_tree_2attr(FILE *file, const char *tag, const char *attr, const char *val, const char *attr2, const char *val2);
void xml_close_tree(FILE *file, const char *tag);
void xml_header(FILE *file, const char *tag);
void xml_list_header(FILE *file, const char *tag);
void xml_footer(FILE *file, const char *tag);
void xml_list_footer(FILE *file, const char *tag);
void xml_name(FILE *file, const struct charinfo_t *charinfo);
void xml_bonus_stats(FILE *file, const struct bonus_stats_t *bonus, const int res_mod);
void xml_stats(FILE *file, const struct stats_t *stats, const struct bonus_stats_t *bonus_stats, const int res_mod);
void xml_skills(FILE *file, const struct charinfo_t *charinfo);
void xml_set_bonus(FILE *file, const struct charinfo_t *charinfo);
void xml_totals(FILE *file, struct charinfo_t *charinfo);
void xml_char(FILE *file, struct charinfo_t *charinfo);
void xml_print(struct charinfo_t *charinfo);

/* xml_items.c */
/* Prints XML data corresponding to items. */
void xml_item_runeword(FILE *file, struct item_t *item);
void xml_item_gemmed(FILE *file, struct item_t *item);
void xml_item_title(FILE *file, struct item_t *item);
void xml_item_tag(FILE *file, struct item_t *item);
void xml_item_rwtag(FILE *file, struct item_t *item);
void xml_item_qual(FILE *file, struct item_t *item);
void xml_item_dmg(FILE *file, struct item_t *item);
void xml_item_defense(FILE *file, struct item_t *item);
void xml_item_block(FILE *file, struct item_t *item);
void xml_item_dura(FILE *file, struct item_t *item);
void xml_item_quant(FILE *file, struct item_t *item);
void xml_item_req(FILE *file, struct item_t *item);
void xml_item_value(FILE *file, struct item_t *item);
void xml_item_level(FILE *file, struct item_t *item);
void xml_prop_list(FILE *file, struct prop_t *prop, const unsigned int clvl);
void xml_item_socket(FILE *file, struct item_t *item);
void xml_item_loc(FILE *file, struct item_t *item);
void xml_item(FILE *file, struct item_t *item, const unsigned int clvl, const uint8 *set_info, const enum char_class_t char_class, const unsigned int id);
void xml_items(FILE *file, const struct charinfo_t *charinfo);

/* xml_list.c */
/* Prints XML data containing overall statistics for an entire server.*/
void xml_list_name(FILE *file, const struct charinfo_t *entry);
void xml_list_exp(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_ival(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_rune(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_gold(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_mf(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_res(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_skill(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_fcr(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_ias(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_melee(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_alive(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_set(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_eardropped(FILE *file, struct charinfo_t **list, const unsigned int entry_count);
void xml_list_time(FILE *file, const double *times);
void xml_list_top(FILE *file, struct list_t *list);
void xml_list(FILE *file, struct list_t *list);
void xml_list_print(struct list_t *list);

#endif
