// Adapted from
// http://www.texsoft.it/index.php?c=software&m=sw.js.htmltooltip&l=it

var active_popup = 0;
var timer;
var state = 6;
var show, pos, rel_x, rel_y;
var show_delay = 500;
var hide_delay = 500;
var old_pos, old_list_pos;

function get_x(obj) {
    var x = 0;
    if(obj.offsetParent) {
	while(obj.offsetParent) {
	    x += obj.offsetLeft;
	    obj = obj.offsetParent; }
    }
    else if(obj.x) {
	x += obj.x; }
    return x; }

function get_y(obj) {
    var y = 0;
    if(obj.offsetParent) {
	while(obj.offsetParent) {
	    y += obj.offsetTop;
	    obj = obj.offsetParent; }
    }
    else if(obj.y) {
	y += obj.y; }
    return y; }

function delay_show_popup(popup, loc, x, y) {
    if(state == 6) {
	return; }
    show = popup;
    pos = loc;
    rel_x = x;
    rel_y = y;
    if(state == 0) {
	state = 1;
	timer = setTimeout("show_popup()", show_delay); }
    else if(state == 1) {
	clearTimeout(timer);
	timer = setTimeout("show_popup()", show_delay); }
}

function preserve_timer(popup) {
    if(popup == active_popup && state == 3) {
	state = 2;
	clearTimeout(timer);
    }
}

function delay_hide_popup() {
    if(state == 6) {
	return; }
    show = 0;
    if(state == 1) {
	clearTimeout(timer); }
    else if(state == 2) {
	state = 3;
	timer = setTimeout("hide_popup()", hide_delay); }
}

function show_popup() {
    if(state != 6) {
	p = document.getElementById(show);
	if(((p.style.top == '' || parseInt(p.style.top) == 0) &&
	    (p.style.left == '' || parseInt(p.style.left) == 0)) ||
	   (parseInt(p.style.top) < window.pageYOffset)) {
	    dst = document.getElementById(pos);
	    if(rel_x + p.offsetWidth > dst.offsetWidth) {
		rel_x = dst.offsetWidth - p.offsetWidth; }
	    if(rel_x < 0) {
		rel_x = 0; }
	    rel_y = dst.offsetHeight - p.offsetHeight - rel_y;
	    rel_x = get_x(dst) + rel_x;
	    var ypos = get_y(dst);
	    if(ypos - p.offsetHeight < window.pageYOffset) {
		rel_y = window.pageYOffset + 10; }
	    else {
		rel_y = ypos + rel_y; }
	    p.style.top = rel_y + 'px';
	    p.style.left = rel_x + 'px';
	}
	active_popup = show;
	state = 2;
	p.style.visibility = 'visible';
    }
}

function hide_popup() {
    if(state == 3) {
	p = document.getElementById(active_popup);
	p.style.visibility = 'hidden';
	active_popup = 0;
	state = 0;
	if(show) {
	    state = 1;
	    timer = setTimeout("show_popup()", show_delay); }
    }
}

function getElementsByClass( searchClass, domNode, tagName) {
    if (domNode == null) domNode = document;
    if (tagName == null) tagName = '*';
    var el = new Array();
    var tags = domNode.getElementsByTagName(tagName);
    var tcl = " "+searchClass+" ";
    for(i=0,j=0; i<tags.length; i++) {
	var test = " " + tags[i].className + " ";
	if (test.indexOf(tcl) != -1)
	    el[j++] = tags[i];
    }
    return el;
}

function hideAllPopups() {
    if(state == 6) {
	var x = 0;
	var p = getElementsByClass("item");
	p = p.concat(getElementsByClass("item_merc"));
	p = p.concat(getElementsByClass("item_ig"));
	p = p.concat(getElementsByClass("item_corpse"));
	old_pos = [];
	for(x = 0; x < p.length; x++) {
	    old_pos[x] = [p[x].style.top, p[x].style.left];
	    p[x].style.visibility = 'hidden';
	    p[x].style.position = 'absolute';
	    p[x].style.top = '0';
	    p[x].style.left = '0';
	}
	p = getElementsByClass("item_brief_list");
	if(p.length >= 1) {
	    p[0].style.display = 'block';
	    p[0].style.visibility = 'visible';
	}
	state = 0;
    }
}

function showAllPopups() {
    if(state != 6) {
	var x = 0;
	var p = getElementsByClass("item");
	p = p.concat(getElementsByClass("item_merc"));
	p = p.concat(getElementsByClass("item_ig"));
	p = p.concat(getElementsByClass("item_corpse"));
	for(x = 0; x < p.length; x++) {
	    p[x].style.position = 'relative';
	    p[x].style.top = old_pos[x][0];
	    p[x].style.left = old_pos[x][1];
	    p[x].style.visibility = 'visible';
	}
	p = getElementsByClass("item_brief_list");
	if(p.length >= 1) {
	    p[0].style.display = 'none';
	    p[0].style.visibility = 'hidden';
	}
	state = 6;
    }
}

onload=hideAllPopups;
