<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
xmlns="http://www.w3.org/1999/xhtml"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:p="http://vidya.dyndns.org/xml/properties">
  <xsl:template name="enhancedType">
    <xsl:param name="var"/>
    <xsl:param name="vartype"/>
    <xsl:param name="display"/>
    <xsl:if test="$var">
      <div class="item_disp_$var">
	<xsl:value-of select="$display"/>
	<span>
	  <xsl:attribute name="class">
	    <xsl:choose>
	      <xsl:when test="$var/@enhanced='yes'">item_<xsl:value-of select="$vartype"/>_enhanced</xsl:when>
	      <xsl:otherwise>item_<xsl:value-of select="$vartype"/></xsl:otherwise>
	    </xsl:choose>
	  </xsl:attribute>
	  <xsl:value-of select="$var"/>
	  <xsl:if test="$vartype='block'">%</xsl:if>
	</span>
      </div>
    </xsl:if>
  </xsl:template>
  <xsl:template match="p:proplist">
    <div>
      <xsl:attribute name="class">
	<xsl:choose>
	  <xsl:when test="@disabled='yes'">plist_disabled</xsl:when>
	  <xsl:when test="@req > 0">plist_set</xsl:when>
	  <xsl:otherwise>plist</xsl:otherwise>
	</xsl:choose>
      </xsl:attribute>
      <xsl:for-each select="p:prop">
	<xsl:if test=".!='(hidden)'">
	  <div class="prop">
	    <xsl:if test="../@req > 0">
	      <span class="prop_set_req">
		(<xsl:value-of select="../@req" />)
	      </span>
	    </xsl:if>
	    <xsl:value-of select="." />
	  </div>
	</xsl:if>
      </xsl:for-each>
    </div>
  </xsl:template>
</xsl:stylesheet>
