<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
xmlns="http://www.w3.org/1999/xhtml"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:i="http://vidya.dyndns.org/xml/items"
xmlns:c="http://vidya.dyndns.org/xml/charinfo"
xmlns:p="http://vidya.dyndns.org/xml/properties">
  <xsl:template name="stats">
    <xsl:param name="var"/>
    <div class="char_stats">
      <div class="stats_head">
	<div class="char_level">
	  Level <xsl:value-of select="$var/c:level"/>
	</div>
	<xsl:if test="$var/c:exp">
	  <div class="char_exp">
	    (<xsl:value-of select="$var/c:exp"/> experience)
	  </div>
	</xsl:if>
      </div>
      <div class="clear"></div>
      <div class="stats_col1">
	<div class="char_str">
	  Str:  <xsl:value-of select="$var/c:str"/>
	  <xsl:if test="$var/c:bonus_str">
	    <span class="char_bonus_str">
	      +<xsl:value-of select="$var/c:bonus_str"/>
	    </span>
	  </xsl:if>
	</div>
	<div class="char_dex">
	  Dex:  <xsl:value-of select="$var/c:dex"/>
	  <xsl:if test="$var/c:bonus_dex">
	    <span class="char_bonus_dex">
	      +<xsl:value-of select="$var/c:bonus_dex"/>
	    </span>
	  </xsl:if>
	</div>
	<div class="char_vit">
	  Vit:  <xsl:value-of select="$var/c:vit"/>
	  <xsl:if test="$var/c:bonus_vit">
	    <span class="char_bonus_vit">
	      +<xsl:value-of select="$var/c:bonus_vit"/>
	    </span>
	  </xsl:if>
	</div>
	<div class="char_ener">
	  Ener: <xsl:value-of select="$var/c:ener"/>
	  <xsl:if test="$var/c:bonus_ener">
	    <span class="char_bonus_ener">
	      +<xsl:value-of select="$var/c:bonus_ener"/>
	    </span>
	  </xsl:if>
	</div>
	<div class="char_resists1">
	  Res:
	  <span class="char_resist_fire">
	    <xsl:value-of select="$var/c:bonus_fire"/>
	  </span>,
	  <span class="char_resist_light">
	    <xsl:value-of select="$var/c:bonus_light"/>
	  </span>
	</div>
	<div class="char_resists2">
	  &#160;&#160;&#160;
	  <span class="char_resist_cold">
	    <xsl:value-of select="$var/c:bonus_pois"/>
	  </span>,
	  <span class="char_resist_pois">
	    <xsl:value-of select="$var/c:bonus_pois"/>
	  </span>
	</div>
	<xsl:if test="$var/c:bonus_def">
	  <div class="char_ac">
	    Defense: <xsl:value-of select="$var/c:bonus_def"/>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_block">
	  <div class="char_block">
	    Block:
	    <span class="bonus_block_percent">
	      <xsl:value-of select="$var/c:bonus_block"/>%
	    </span>
	    <xsl:if test="$var/c:bonus_block_speed">
	      <span class="bonus_block_speed">
		(<xsl:value-of select="$var/c:bonus_block_speed"/>% faster)
	      </span>
	    </xsl:if>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_ll or $var/c:bonus_ml">
	  <div class="char_leech">
	    Leech:
	    <xsl:choose>
	      <xsl:when test="$var/c:bonus_ll"><span class="char_ll"><xsl:value-of select="$var/c:bonus_ll"/>% </span></xsl:when>
	      <xsl:otherwise><span class="char_no_ll">0% </span></xsl:otherwise>
	    </xsl:choose>
	    <xsl:choose>
	      <xsl:when test="$var/c:bonus_ml"><span class="char_ml"><xsl:value-of select="$var/c:bonus_ml"/>%</span></xsl:when>
	      <xsl:otherwise><span class="char_no_ml">0%</span></xsl:otherwise>
	    </xsl:choose>
	  </div>
	</xsl:if>
      </div>
      <div class="stats_col2">
	<xsl:if test="$var/c:life">
	  <div class="char_life">
	    Life: <xsl:value-of select="$var/c:life"/>
	    <xsl:if test="$var/c:bonus_life">
	      <span class="char_bonus_life">
		+<xsl:value-of select="$var/c:bonus_life"/>
	      </span>
	    </xsl:if>
	    <xsl:if test="$var/c:bonus_life_mult">
	      <span class="char_bonus_life_mult">
		+<xsl:value-of select="$var/c:bonus_life_mult"/>%
	      </span>
	    </xsl:if>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:stam">
	  <div class="char_stam">
	    Stam: <xsl:value-of select="$var/c:stam"/>
	    <xsl:if test="$var/c:bonus_stam">
	      <span class="char_bonus_stam">
		+<xsl:value-of select="$var/c:bonus_stam"/>
	      </span>
	    </xsl:if>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:mana">
	  <div class="char_mana">
	    Mana: <xsl:value-of select="$var/c:mana"/>
	    <xsl:if test="$var/c:bonus_mana">
	      <span class="char_bonus_mana">
		+<xsl:value-of select="$var/c:bonus_mana"/>
	      </span>
	    </xsl:if>
	    <xsl:if test="$var/c:bonus_mana_mult">
	      <span class="char_bonus_mana_mult">
		+<xsl:value-of select="$var/c:bonus_mana_mult"/>%
	      </span>
	    </xsl:if>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_ar">
	  <div class="char_ar">
	    AR:
	    <xsl:choose>
	      <xsl:when test="$var/c:bonus_ignore_ac='yes'">
		<span class="char_ar_ignore">
		  Infinite
		</span>
	      </xsl:when>
	      <xsl:otherwise>
		<span class="char_ar_add">
		  +<xsl:value-of select="$var/c:bonus_ar"/>
		</span>
		<xsl:if test="$var/c:bonus_ar_mult">
		  <span class="char_ar_mult">
		    +<xsl:value-of select="$var/c:bonus_ar_mult"/>%
		  </span>
		</xsl:if>
	      </xsl:otherwise>
	    </xsl:choose>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_fcr">
	  <div class="char_fcr">
	    FCR: <xsl:value-of select="$var/c:bonus_fcr"/>%
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_ias">
	  <div class="char_ias">
	    IAS: <xsl:value-of select="$var/c:bonus_ias"/>%
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_cb or $var/c:bonus_ds or $var/c:bonus_ow">
	  <div class="char_meleestats">
	    <xsl:if test="$var/c:bonus_ow">
	      OW: <xsl:value-of select="$var/c:bonus_ow"/>%
	    </xsl:if>
	    <xsl:if test="$var/c:bonus_cb">
	      CB: <xsl:value-of select="$var/c:bonus_cb"/>%
	    </xsl:if>
	    <xsl:if test="$var/c:bonus_ds">
	      DS: <xsl:value-of select="$var/c:bonus_ds"/>%
	    </xsl:if>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:bonus_mf">
	  <div class="char_mf">
	    Magic find: <xsl:value-of select="$var/c:bonus_mf"/>%
	  </div>
	</xsl:if>
      </div>
      <div class="stats_foot">
	<xsl:if test="$var/c:gold">
	  <div class="char_gold">
	    Gold: <xsl:value-of select="$var/c:gold"/>
	  </div>
	</xsl:if>
	<xsl:if test="$var/c:stash">
	  <div class="char_stash">
	    Gold in Stash: <xsl:value-of select="$var/c:stash"/>
	  </div>
	</xsl:if>
      </div>
    </div>
  </xsl:template>
  <xsl:template match="c:skills">
    <div class="char_skills">
      <xsl:if test="c:spec">
	<div class="char_spec">
	  Skills:
	  <span class="char_spec_val"><xsl:value-of select="c:spec"/></span>
	</div>
      </xsl:if>
      <xsl:for-each select="c:skill">
	<xsl:sort select="c:level" data-type="number" order="descending"/>
	<div class="char_skill">
	  Level <xsl:choose><xsl:when test="c:level"><xsl:value-of select="c:level"/></xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>&#160;<xsl:value-of select="c:name"/>
	  <xsl:if test="c:bonus_level">
	    <span class="char_skill_bonus">
	      +<xsl:value-of select="c:bonus_level"/>
	    </span>
	  </xsl:if>
	</div>
      </xsl:for-each>
      <xsl:if test="c:bonus_all_skills or c:bonus_tab1 or c:bonus_tab2 or bonus_tab3">
	<div class="char_bonus_skills">
	  Bonuses:
	  <xsl:choose><xsl:when test="c:bonus_all_skills!=0"><span class="char_bonus_allskills"><xsl:value-of select="c:bonus_all_skills"/></span></xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>/<xsl:choose><xsl:when test="c:bonus_tab1!=0"><span class="char_bonus_tab1"><xsl:value-of select="c:bonus_tab1"/></span></xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>/<xsl:choose><xsl:when test="c:bonus_tab2!=0"><span class="char_bonus_tab2"><xsl:value-of select="c:bonus_tab2"/></span></xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>/<xsl:choose><xsl:when test="c:bonus_tab3!=0"><span class="char_bonus_tab3"><xsl:value-of select="c:bonus_tab3"/></span></xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>
	</div>
      </xsl:if>
    </div>
  </xsl:template>
  <xsl:template match="c:charinfo">
    <div id="container_top">
      <div class="char_left">
	<div class="char_head">
	  <div>
	    <xsl:attribute name="class">
	      <xsl:choose>
		<xsl:when test="not(c:hardcore) and c:has_died='no'">char_fullname_notdead</xsl:when>
		<xsl:when test="c:hardcore and c:has_died='no'">char_fullname_hc</xsl:when>
		<xsl:when test="c:hardcore and c:has_died='yes'">char_fullname_dead</xsl:when>
		<xsl:otherwise>char_fullname</xsl:otherwise>
	      </xsl:choose>
	    </xsl:attribute>
	    <xsl:if test="c:chartitle"><span class="char_title"><xsl:value-of select="c:chartitle"/>&#160;</span></xsl:if><span class="char_name"><xsl:value-of select="c:name"/></span>
	  </div>
	  <div class="char_class">
	    <xsl:value-of select="c:class"/>
	  </div>
	  <xsl:if test="c:ladder">
	    <div class="char_ladder">
	      (Ladder Character)
	    </div>
	  </xsl:if>
	  <xsl:if test="c:hardcore and c:has_died='yes'">
	    <div class="char_rip">
	      Your deeds of valor will be remembered ;_;
	    </div>
	  </xsl:if>
	</div>
	<div class="clear"></div>
	<xsl:call-template name="stats">
	  <xsl:with-param name="var" select="c:stats"/>
	</xsl:call-template>
	<div class="clear"></div>
	<xsl:if test="c:set_bonus">
	  <div class="char_set_bonus">
	    Set bonuses:
	    <xsl:for-each select="c:set_bonus/c:set">
	      <xsl:sort select="c:setcount"/>
	      <div class="set">
		<span class="set_name">
		  <xsl:value-of select="c:setname"/>
		</span>
		<span class="set_count">
		  (<xsl:value-of select="c:setcount"/>)
		</span>
	      </div>
	      <xsl:apply-templates select="p:proplist"/>
	    </xsl:for-each>
	  </div>
	</xsl:if>
      </div>
      <div class="char_right">
	<xsl:apply-templates select="c:skills"/>
      </div>
    </div>
    <div class="clear"></div>
    <xsl:if test="c:totals">
      <div class="char_totals">
	<div class="char_total_title">Extra bonuses: (equipped items only)</div>
	<xsl:for-each select="c:totals/p:proplist/p:prop">
	  <xsl:if test=".!='(hidden)'">
	    <div class="prop_total">
	      <xsl:if test="../@req > 0">
		<span class="prop_set_req">
		  (<xsl:value-of select="../@req" />)
		</span>
	      </xsl:if>
	      <xsl:value-of select="." />
	    </div>
	  </xsl:if>
	</xsl:for-each>
      </div>
    </xsl:if>
    <div class="clear"></div>
    <div class="buttons">
      <span class="button" onclick="document.getElementById('radio_list').checked = true; hideAllPopups();"><input id="radio_list" type="radio" value="list" name="g1" checked="checked"/>List</span>
      <span class="button" onclick="document.getElementById('radio_block').checked = true; showAllPopups();"><input id="radio_block" type="radio" value="block" name="g1"/>Block</span>
    </div>
    <xsl:apply-templates select="i:itemlist"/>
  </xsl:template>
</xsl:stylesheet>
